// @TITLE "prefix.cc -- prefix sum, manually"
//
// prefix -- prefix sum, manually
//   written using the Data-Parallel Programming Library for Education (DAPPLE)
//
// Of course, DAPPLE includes a sum scan function, so this is not 
// necessary, but it is a good exercise.  Each time, the vector is
// shifted twice as far, and then add into itself.  Note that
// the left-most M processors will add 0 after log(M) iterations.
// This solution works for any size list.
//
// David Kotz 1994

// $Id: prefix.cc,v 2.17 95/12/17 00:08:17 dfk release Locker: dfk $

#include <stdlib.h>
#include <iostream.h>
#include <math.h>
#include "dapple.h"

const int N = 11;

int
main()
{
    intVector v(N);		// the intVector to prefix sum
    intVector prefix(N);	// where we get the prefix sum
    int m = 1;			// current shift distance

    // 6 5 9 2 4 3 5 1 7 5 8
    cout << "Enter vector of " << N << " integers: ";
    cin >> v;
    cout << endl;

    prefix = shift(v, 1);	// start with an initial shift

    cout << prefix << endl;

    while (m < N) {
	prefix += shift(prefix, m); // shift it over this far
				   // note: left-most m processors will add 0
	m *= 2;			   // double the distance next time

	cout << prefix << endl;
    }

    cout << "verification:" << endl;
    cout << plus_scan(v) << endl;

    return(0);
}
