// @TITLE "macros.h: some basic macros"
//
//  macros.h: some basic macros for DAPPLE
//
// David Kotz 1994
//

// $Id: macros.h,v 2.16 95/12/17 00:07:48 dfk release Locker: dfk $

#ifndef MACROS_H
#define MACROS_H

// In some compilers, const causes a lot of trouble.
// Define CONST to be the empty string to make it all go away.
#define CONST const

// Some convenient macros
#define odd(x) ((x) % 2 == 1)
#define even(x) ((x) % 2 == 0)

// int max and min functions; may be overloaded for other types too
inline int max(CONST int x, CONST int y) { return (x > y ? x : y); }
inline int min(CONST int x, CONST int y) { return (x < y ? x : y); }

inline int two(CONST int x) { return (1 << x); }

// boolean values

#ifdef __MWERKS__        // Metrowerks Codewarrior
typedef Boolean boolean;
#else
#ifdef _AIX  // at least, CSet++ for AIX has no boolean type(?)
typedef short boolean;
#else
typedef bool boolean;
#endif
#endif

#ifndef __GNUG__  // GNU c++
#undef false
#undef true
CONST boolean false = 0;
CONST boolean true = 1;
#endif

#endif // MACROS_H
